Index: /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs	(revision 16899)
@@ -180,18 +180,18 @@
 
     private InterpreterState PrepareInterpreterState(ISymbolicExpressionTree tree, IDataset dataset) {
-      Instruction[] code = SymbolicExpressionTreeCompiler.Compile(tree, OpCodes.MapSymbolToOpCode);
+      Instruction[] code = SymbolicExpressionTreeCompiler.Compile(tree, OpCode.MapSymbolToOpCode);
       Dictionary<string, int> doubleVariableNames = dataset.DoubleVariables.Select((x, i) => new { x, i }).ToDictionary(e => e.x, e => e.i);
       int necessaryArgStackSize = 0;
       foreach (Instruction instr in code) {
-        if (instr.opCode == OpCodes.Variable) {
+        if (instr.opCode == OpCode.Variable) {
           var variableTreeNode = (VariableTreeNode)instr.dynamicNode;
           instr.data = doubleVariableNames[variableTreeNode.VariableName];
-        } else if (instr.opCode == OpCodes.LagVariable) {
+        } else if (instr.opCode == OpCode.LagVariable) {
           var laggedVariableTreeNode = (LaggedVariableTreeNode)instr.dynamicNode;
           instr.data = doubleVariableNames[laggedVariableTreeNode.VariableName];
-        } else if (instr.opCode == OpCodes.VariableCondition) {
+        } else if (instr.opCode == OpCode.VariableCondition) {
           var variableConditionTreeNode = (VariableConditionTreeNode)instr.dynamicNode;
           instr.data = doubleVariableNames[variableConditionTreeNode.VariableName];
-        } else if (instr.opCode == OpCodes.Call) {
+        } else if (instr.opCode == OpCode.Call) {
           necessaryArgStackSize += instr.nArguments + 1;
         }
@@ -205,5 +205,5 @@
 
       switch (currentInstr.opCode) {
-        case OpCodes.Add: {
+        case OpCode.Add: {
             if (nArgs > 0) {
               CompileInstructions(il, state, ds);
@@ -215,5 +215,5 @@
             return;
           }
-        case OpCodes.Sub: {
+        case OpCode.Sub: {
             if (nArgs == 1) {
               CompileInstructions(il, state, ds);
@@ -230,5 +230,5 @@
             return;
           }
-        case OpCodes.Mul: {
+        case OpCode.Mul: {
             if (nArgs > 0) {
               CompileInstructions(il, state, ds);
@@ -240,5 +240,5 @@
             return;
           }
-        case OpCodes.Div: {
+        case OpCode.Div: {
             if (nArgs == 1) {
               il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, 1.0);
@@ -256,5 +256,5 @@
             return;
           }
-        case OpCodes.Average: {
+        case OpCode.Average: {
             CompileInstructions(il, state, ds);
             for (int i = 1; i < nArgs; i++) {
@@ -266,30 +266,30 @@
             return;
           }
-        case OpCodes.Absolute: {
+        case OpCode.Absolute: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, abs);
             return;
           }
-        case OpCodes.Cos: {
+        case OpCode.Cos: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, cos);
             return;
           }
-        case OpCodes.Sin: {
+        case OpCode.Sin: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, sin);
             return;
           }
-        case OpCodes.Tan: {
+        case OpCode.Tan: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, tan);
             return;
           }
-        case OpCodes.Tanh: {
+        case OpCode.Tanh: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, tanh);
             return;
           }
-        case OpCodes.Power: {
+        case OpCode.Power: {
             CompileInstructions(il, state, ds);
             CompileInstructions(il, state, ds);
@@ -298,5 +298,5 @@
             return;
           }
-        case OpCodes.Root: {
+        case OpCode.Root: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, 1.0); // 1 / round(...)
@@ -307,15 +307,15 @@
             return;
           }
-        case OpCodes.Exp: {
+        case OpCode.Exp: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, exp);
             return;
           }
-        case OpCodes.Log: {
+        case OpCode.Log: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, log);
             return;
           }
-        case OpCodes.Square: {
+        case OpCode.Square: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, 2.0);
@@ -323,5 +323,5 @@
             return;
           }
-        case OpCodes.Cube: {
+        case OpCode.Cube: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, 3.0);
@@ -329,10 +329,10 @@
             return;
           }
-        case OpCodes.SquareRoot: {
+        case OpCode.SquareRoot: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, sqrt);
             return;
           }
-        case OpCodes.CubeRoot: {
+        case OpCode.CubeRoot: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, 1.0 / 3.0);
@@ -340,80 +340,80 @@
             return;
           }
-        case OpCodes.AiryA: {
+        case OpCode.AiryA: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, airyA);
             return;
           }
-        case OpCodes.AiryB: {
+        case OpCode.AiryB: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, airyB);
             return;
           }
-        case OpCodes.Bessel: {
+        case OpCode.Bessel: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, bessel);
             return;
           }
-        case OpCodes.CosineIntegral: {
+        case OpCode.CosineIntegral: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, cosIntegral);
             return;
           }
-        case OpCodes.Dawson: {
+        case OpCode.Dawson: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, dawson);
             return;
           }
-        case OpCodes.Erf: {
+        case OpCode.Erf: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, erf);
             return;
           }
-        case OpCodes.ExponentialIntegralEi: {
+        case OpCode.ExponentialIntegralEi: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, expIntegralEi);
             return;
           }
-        case OpCodes.FresnelCosineIntegral: {
+        case OpCode.FresnelCosineIntegral: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, fresnelCosIntegral);
             return;
           }
-        case OpCodes.FresnelSineIntegral: {
+        case OpCode.FresnelSineIntegral: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, fresnelSinIntegral);
             return;
           }
-        case OpCodes.Gamma: {
+        case OpCode.Gamma: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, gamma);
             return;
           }
-        case OpCodes.HyperbolicCosineIntegral: {
+        case OpCode.HyperbolicCosineIntegral: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, hypCosIntegral);
             return;
           }
-        case OpCodes.HyperbolicSineIntegral: {
+        case OpCode.HyperbolicSineIntegral: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, hypSinIntegral);
             return;
           }
-        case OpCodes.Norm: {
+        case OpCode.Norm: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, norm);
             return;
           }
-        case OpCodes.Psi: {
+        case OpCode.Psi: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, psi);
             return;
           }
-        case OpCodes.SineIntegral: {
+        case OpCode.SineIntegral: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Call, sinIntegral);
             return;
           }
-        case OpCodes.AnalyticQuotient: {
+        case OpCode.AnalyticQuotient: {
             CompileInstructions(il, state, ds); // x1
             CompileInstructions(il, state, ds); // x2
@@ -427,5 +427,5 @@
             return;
           }
-        case OpCodes.IfThenElse: {
+        case OpCode.IfThenElse: {
             Label end = il.DefineLabel();
             Label c1 = il.DefineLabel();
@@ -441,5 +441,5 @@
             return;
           }
-        case OpCodes.AND: {
+        case OpCode.AND: {
             Label falseBranch = il.DefineLabel();
             Label end = il.DefineLabel();
@@ -462,5 +462,5 @@
             return;
           }
-        case OpCodes.OR: {
+        case OpCode.OR: {
             Label trueBranch = il.DefineLabel();
             Label end = il.DefineLabel();
@@ -490,5 +490,5 @@
             return;
           }
-        case OpCodes.NOT: {
+        case OpCode.NOT: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, 0.0); // > 0
@@ -502,5 +502,5 @@
             return;
           }
-        case OpCodes.XOR: {
+        case OpCode.XOR: {
             CompileInstructions(il, state, ds);
             il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, 0.0);
@@ -521,5 +521,5 @@
             return;
           }
-        case OpCodes.GT: {
+        case OpCode.GT: {
             CompileInstructions(il, state, ds);
             CompileInstructions(il, state, ds);
@@ -533,5 +533,5 @@
             return;
           }
-        case OpCodes.LT: {
+        case OpCode.LT: {
             CompileInstructions(il, state, ds);
             CompileInstructions(il, state, ds);
@@ -544,5 +544,5 @@
             return;
           }
-        case OpCodes.TimeLag: {
+        case OpCode.TimeLag: {
             LaggedTreeNode laggedTreeNode = (LaggedTreeNode)currentInstr.dynamicNode;
             il.Emit(System.Reflection.Emit.OpCodes.Ldarg_0); // row -= lag
@@ -560,5 +560,5 @@
             return;
           }
-        case OpCodes.Integral: {
+        case OpCode.Integral: {
             int savedPc = state.ProgramCounter;
             LaggedTreeNode laggedTreeNode = (LaggedTreeNode)currentInstr.dynamicNode;
@@ -587,5 +587,5 @@
         //one sided smooth differentiatior, N = 4
         // y' = 1/8h (f_i + 2f_i-1, -2 f_i-3 - f_i-4)
-        case OpCodes.Derivative: {
+        case OpCode.Derivative: {
             int savedPc = state.ProgramCounter;
             CompileInstructions(il, state, ds);
@@ -629,13 +629,13 @@
             return;
           }
-        case OpCodes.Call: {
+        case OpCode.Call: {
             throw new NotSupportedException(
               "Automatically defined functions are not supported by the SymbolicDataAnalysisTreeILEmittingInterpreter. Either turn of ADFs or change the interpeter.");
           }
-        case OpCodes.Arg: {
+        case OpCode.Arg: {
             throw new NotSupportedException(
               "Automatically defined functions are not supported by the SymbolicDataAnalysisTreeILEmittingInterpreter. Either turn of ADFs or change the interpeter.");
           }
-        case OpCodes.Variable: {
+        case OpCode.Variable: {
             VariableTreeNode varNode = (VariableTreeNode)currentInstr.dynamicNode;
             il.Emit(System.Reflection.Emit.OpCodes.Ldarg_1); // load columns array
@@ -669,5 +669,5 @@
             return;
           }
-        case OpCodes.LagVariable: {
+        case OpCode.LagVariable: {
             var nanResult = il.DefineLabel();
             var normalResult = il.DefineLabel();
@@ -697,5 +697,5 @@
             return;
           }
-        case OpCodes.Constant: {
+        case OpCode.Constant: {
             ConstantTreeNode constNode = (ConstantTreeNode)currentInstr.dynamicNode;
             il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, constNode.Value);
@@ -705,5 +705,5 @@
         //mkommend: this symbol uses the logistic function f(x) = 1 / (1 + e^(-alpha * x) ) 
         //to determine the relative amounts of the true and false branch see http://en.wikipedia.org/wiki/Logistic_function
-        case OpCodes.VariableCondition: {
+        case OpCode.VariableCondition: {
             throw new NotSupportedException("Interpretation of symbol " + currentInstr.dynamicNode.Symbol.Name +
                                             " is not supported by the SymbolicDataAnalysisTreeILEmittingInterpreter");
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 16899)
@@ -137,23 +137,23 @@
 
     private static InterpreterState PrepareInterpreterState(ISymbolicExpressionTree tree, IDataset dataset) {
-      Instruction[] code = SymbolicExpressionTreeCompiler.Compile(tree, OpCodes.MapSymbolToOpCode);
+      Instruction[] code = SymbolicExpressionTreeCompiler.Compile(tree, OpCode.MapSymbolToOpCode);
       int necessaryArgStackSize = 0;
       foreach (Instruction instr in code) {
-        if (instr.opCode == OpCodes.Variable) {
+        if (instr.opCode == OpCode.Variable) {
           var variableTreeNode = (VariableTreeNode)instr.dynamicNode;
           instr.data = dataset.GetReadOnlyDoubleValues(variableTreeNode.VariableName);
-        } else if (instr.opCode == OpCodes.FactorVariable) {
+        } else if (instr.opCode == OpCode.FactorVariable) {
           var factorTreeNode = instr.dynamicNode as FactorVariableTreeNode;
           instr.data = dataset.GetReadOnlyStringValues(factorTreeNode.VariableName);
-        } else if (instr.opCode == OpCodes.BinaryFactorVariable) {
+        } else if (instr.opCode == OpCode.BinaryFactorVariable) {
           var factorTreeNode = instr.dynamicNode as BinaryFactorVariableTreeNode;
           instr.data = dataset.GetReadOnlyStringValues(factorTreeNode.VariableName);
-        } else if (instr.opCode == OpCodes.LagVariable) {
+        } else if (instr.opCode == OpCode.LagVariable) {
           var laggedVariableTreeNode = (LaggedVariableTreeNode)instr.dynamicNode;
           instr.data = dataset.GetReadOnlyDoubleValues(laggedVariableTreeNode.VariableName);
-        } else if (instr.opCode == OpCodes.VariableCondition) {
+        } else if (instr.opCode == OpCode.VariableCondition) {
           var variableConditionTreeNode = (VariableConditionTreeNode)instr.dynamicNode;
           instr.data = dataset.GetReadOnlyDoubleValues(variableConditionTreeNode.VariableName);
-        } else if (instr.opCode == OpCodes.Call) {
+        } else if (instr.opCode == OpCode.Call) {
           necessaryArgStackSize += instr.nArguments + 1;
         }
@@ -165,5 +165,5 @@
       Instruction currentInstr = state.NextInstruction();
       switch (currentInstr.opCode) {
-        case OpCodes.Add: {
+        case OpCode.Add: {
             double s = Evaluate(dataset, ref row, state);
             for (int i = 1; i < currentInstr.nArguments; i++) {
@@ -172,5 +172,5 @@
             return s;
           }
-        case OpCodes.Sub: {
+        case OpCode.Sub: {
             double s = Evaluate(dataset, ref row, state);
             for (int i = 1; i < currentInstr.nArguments; i++) {
@@ -180,5 +180,5 @@
             return s;
           }
-        case OpCodes.Mul: {
+        case OpCode.Mul: {
             double p = Evaluate(dataset, ref row, state);
             for (int i = 1; i < currentInstr.nArguments; i++) {
@@ -187,5 +187,5 @@
             return p;
           }
-        case OpCodes.Div: {
+        case OpCode.Div: {
             double p = Evaluate(dataset, ref row, state);
             for (int i = 1; i < currentInstr.nArguments; i++) {
@@ -195,5 +195,5 @@
             return p;
           }
-        case OpCodes.Average: {
+        case OpCode.Average: {
             double sum = Evaluate(dataset, ref row, state);
             for (int i = 1; i < currentInstr.nArguments; i++) {
@@ -202,52 +202,52 @@
             return sum / currentInstr.nArguments;
           }
-        case OpCodes.Absolute: {
+        case OpCode.Absolute: {
             return Math.Abs(Evaluate(dataset, ref row, state));
           }
-        case OpCodes.Tanh: {
+        case OpCode.Tanh: {
             return Math.Tanh(Evaluate(dataset, ref row, state));
           }
-        case OpCodes.Cos: {
+        case OpCode.Cos: {
             return Math.Cos(Evaluate(dataset, ref row, state));
           }
-        case OpCodes.Sin: {
+        case OpCode.Sin: {
             return Math.Sin(Evaluate(dataset, ref row, state));
           }
-        case OpCodes.Tan: {
+        case OpCode.Tan: {
             return Math.Tan(Evaluate(dataset, ref row, state));
           }
-        case OpCodes.Square: {
+        case OpCode.Square: {
             return Math.Pow(Evaluate(dataset, ref row, state), 2);
           }
-        case OpCodes.Cube: {
+        case OpCode.Cube: {
             return Math.Pow(Evaluate(dataset, ref row, state), 3);
           }
-        case OpCodes.Power: {
+        case OpCode.Power: {
             double x = Evaluate(dataset, ref row, state);
             double y = Math.Round(Evaluate(dataset, ref row, state));
             return Math.Pow(x, y);
           }
-        case OpCodes.SquareRoot: {
+        case OpCode.SquareRoot: {
             return Math.Sqrt(Evaluate(dataset, ref row, state));
           }
-        case OpCodes.CubeRoot: {
+        case OpCode.CubeRoot: {
             return Math.Pow(Evaluate(dataset, ref row, state), 1.0 / 3.0);
           }
-        case OpCodes.Root: {
+        case OpCode.Root: {
             double x = Evaluate(dataset, ref row, state);
             double y = Math.Round(Evaluate(dataset, ref row, state));
             return Math.Pow(x, 1 / y);
           }
-        case OpCodes.Exp: {
+        case OpCode.Exp: {
             return Math.Exp(Evaluate(dataset, ref row, state));
           }
-        case OpCodes.Log: {
+        case OpCode.Log: {
             return Math.Log(Evaluate(dataset, ref row, state));
           }
-        case OpCodes.Gamma: {
+        case OpCode.Gamma: {
             var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) { return double.NaN; } else { return alglib.gammafunction(x); }
           }
-        case OpCodes.Psi: {
+        case OpCode.Psi: {
             var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
@@ -255,15 +255,15 @@
             return alglib.psi(x);
           }
-        case OpCodes.Dawson: {
+        case OpCode.Dawson: {
             var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) { return double.NaN; }
             return alglib.dawsonintegral(x);
           }
-        case OpCodes.ExponentialIntegralEi: {
+        case OpCode.ExponentialIntegralEi: {
             var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) { return double.NaN; }
             return alglib.exponentialintegralei(x);
           }
-        case OpCodes.SineIntegral: {
+        case OpCode.SineIntegral: {
             double si, ci;
             var x = Evaluate(dataset, ref row, state);
@@ -274,5 +274,5 @@
             }
           }
-        case OpCodes.CosineIntegral: {
+        case OpCode.CosineIntegral: {
             double si, ci;
             var x = Evaluate(dataset, ref row, state);
@@ -283,5 +283,5 @@
             }
           }
-        case OpCodes.HyperbolicSineIntegral: {
+        case OpCode.HyperbolicSineIntegral: {
             double shi, chi;
             var x = Evaluate(dataset, ref row, state);
@@ -292,5 +292,5 @@
             }
           }
-        case OpCodes.HyperbolicCosineIntegral: {
+        case OpCode.HyperbolicCosineIntegral: {
             double shi, chi;
             var x = Evaluate(dataset, ref row, state);
@@ -301,5 +301,5 @@
             }
           }
-        case OpCodes.FresnelCosineIntegral: {
+        case OpCode.FresnelCosineIntegral: {
             double c = 0, s = 0;
             var x = Evaluate(dataset, ref row, state);
@@ -310,5 +310,5 @@
             }
           }
-        case OpCodes.FresnelSineIntegral: {
+        case OpCode.FresnelSineIntegral: {
             double c = 0, s = 0;
             var x = Evaluate(dataset, ref row, state);
@@ -319,5 +319,5 @@
             }
           }
-        case OpCodes.AiryA: {
+        case OpCode.AiryA: {
             double ai, aip, bi, bip;
             var x = Evaluate(dataset, ref row, state);
@@ -328,5 +328,5 @@
             }
           }
-        case OpCodes.AiryB: {
+        case OpCode.AiryB: {
             double ai, aip, bi, bip;
             var x = Evaluate(dataset, ref row, state);
@@ -337,15 +337,15 @@
             }
           }
-        case OpCodes.Norm: {
+        case OpCode.Norm: {
             var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else return alglib.normaldistribution(x);
           }
-        case OpCodes.Erf: {
+        case OpCode.Erf: {
             var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
             else return alglib.errorfunction(x);
           }
-        case OpCodes.Bessel: {
+        case OpCode.Bessel: {
             var x = Evaluate(dataset, ref row, state);
             if (double.IsNaN(x)) return double.NaN;
@@ -353,10 +353,10 @@
           }
 
-        case OpCodes.AnalyticQuotient: {
+        case OpCode.AnalyticQuotient: {
             var x1 = Evaluate(dataset, ref row, state);
             var x2 = Evaluate(dataset, ref row, state);
             return x1 / Math.Pow(1 + x2 * x2, 0.5);
           }
-        case OpCodes.IfThenElse: {
+        case OpCode.IfThenElse: {
             double condition = Evaluate(dataset, ref row, state);
             double result;
@@ -368,5 +368,5 @@
             return result;
           }
-        case OpCodes.AND: {
+        case OpCode.AND: {
             double result = Evaluate(dataset, ref row, state);
             for (int i = 1; i < currentInstr.nArguments; i++) {
@@ -378,5 +378,5 @@
             return result > 0.0 ? 1.0 : -1.0;
           }
-        case OpCodes.OR: {
+        case OpCode.OR: {
             double result = Evaluate(dataset, ref row, state);
             for (int i = 1; i < currentInstr.nArguments; i++) {
@@ -388,8 +388,8 @@
             return result > 0.0 ? 1.0 : -1.0;
           }
-        case OpCodes.NOT: {
+        case OpCode.NOT: {
             return Evaluate(dataset, ref row, state) > 0.0 ? -1.0 : 1.0;
           }
-        case OpCodes.XOR: {
+        case OpCode.XOR: {
             //mkommend: XOR on multiple inputs is defined as true if the number of positive signals is odd
             // this is equal to a consecutive execution of binary XOR operations.
@@ -400,15 +400,15 @@
             return positiveSignals % 2 != 0 ? 1.0 : -1.0;
           }
-        case OpCodes.GT: {
+        case OpCode.GT: {
             double x = Evaluate(dataset, ref row, state);
             double y = Evaluate(dataset, ref row, state);
             if (x > y) { return 1.0; } else { return -1.0; }
           }
-        case OpCodes.LT: {
+        case OpCode.LT: {
             double x = Evaluate(dataset, ref row, state);
             double y = Evaluate(dataset, ref row, state);
             if (x < y) { return 1.0; } else { return -1.0; }
           }
-        case OpCodes.TimeLag: {
+        case OpCode.TimeLag: {
             var timeLagTreeNode = (LaggedTreeNode)currentInstr.dynamicNode;
             row += timeLagTreeNode.Lag;
@@ -417,5 +417,5 @@
             return result;
           }
-        case OpCodes.Integral: {
+        case OpCode.Integral: {
             int savedPc = state.ProgramCounter;
             var timeLagTreeNode = (LaggedTreeNode)currentInstr.dynamicNode;
@@ -435,5 +435,5 @@
         //one sided smooth differentiatior, N = 4
         // y' = 1/8h (f_i + 2f_i-1, -2 f_i-3 - f_i-4)
-        case OpCodes.Derivative: {
+        case OpCode.Derivative: {
             int savedPc = state.ProgramCounter;
             double f_0 = Evaluate(dataset, ref row, state); row--;
@@ -448,5 +448,5 @@
             return (f_0 + 2 * f_1 - 2 * f_3 - f_4) / 8; // h = 1
           }
-        case OpCodes.Call: {
+        case OpCode.Call: {
             // evaluate sub-trees
             double[] argValues = new double[currentInstr.nArguments];
@@ -471,23 +471,23 @@
             return v;
           }
-        case OpCodes.Arg: {
+        case OpCode.Arg: {
             return state.GetStackFrameValue((ushort)currentInstr.data);
           }
-        case OpCodes.Variable: {
+        case OpCode.Variable: {
             if (row < 0 || row >= dataset.Rows) return double.NaN;
             var variableTreeNode = (VariableTreeNode)currentInstr.dynamicNode;
             return ((IList<double>)currentInstr.data)[row] * variableTreeNode.Weight;
           }
-        case OpCodes.BinaryFactorVariable: {
+        case OpCode.BinaryFactorVariable: {
             if (row < 0 || row >= dataset.Rows) return double.NaN;
             var factorVarTreeNode = currentInstr.dynamicNode as BinaryFactorVariableTreeNode;
             return ((IList<string>)currentInstr.data)[row] == factorVarTreeNode.VariableValue ? factorVarTreeNode.Weight : 0;
           }
-        case OpCodes.FactorVariable: {
+        case OpCode.FactorVariable: {
             if (row < 0 || row >= dataset.Rows) return double.NaN;
             var factorVarTreeNode = currentInstr.dynamicNode as FactorVariableTreeNode;
             return factorVarTreeNode.GetValue(((IList<string>)currentInstr.data)[row]);
           }
-        case OpCodes.LagVariable: {
+        case OpCode.LagVariable: {
             var laggedVariableTreeNode = (LaggedVariableTreeNode)currentInstr.dynamicNode;
             int actualRow = row + laggedVariableTreeNode.Lag;
@@ -495,5 +495,5 @@
             return ((IList<double>)currentInstr.data)[actualRow] * laggedVariableTreeNode.Weight;
           }
-        case OpCodes.Constant: {
+        case OpCode.Constant: {
             var constTreeNode = (ConstantTreeNode)currentInstr.dynamicNode;
             return constTreeNode.Value;
@@ -502,5 +502,5 @@
         //mkommend: this symbol uses the logistic function f(x) = 1 / (1 + e^(-alpha * x) ) 
         //to determine the relative amounts of the true and false branch see http://en.wikipedia.org/wiki/Logistic_function
-        case OpCodes.VariableCondition: {
+        case OpCode.VariableCondition: {
             if (row < 0 || row >= dataset.Rows) return double.NaN;
             var variableConditionTreeNode = (VariableConditionTreeNode)currentInstr.dynamicNode;
